
While the majority of Tcllib consists of packages written in pure Tcl
a number of packages also have [term accelerators] associated with them.

[para] These are [syscmd critcl]-based C packages whose use will boost
       the performance of the packages using them.

While they are built by default on Unix (see [emph {make install}]),
they are not required, they are [emph optional].

[para] When building the accelerators the normally optional dependency
       on [syscmd critcl] becomes required.

If they are built according to the instructions below then they will
also be installed as well.

[para] To build and install Tcllib with the accelerators in a
       Unix-like environment invoke:

[example {
  ./configure
  make
  # or
  make install
  # or
  make install-binaries
}]

[para] The underlying tool is [file sak.tcl] in the toplevel directory
       of Tcllib and the [cmd {make install-binaries}] target is just
       a wrapper around

[example {
  ./sak.tcl critcl
}]

[para] Therefore in a Windows environment instead invoke

[example {
  ./sak.tcl critcl
  ./installer.tcl
}]

from within a DOS window, i.e. [syscmd cmd.exe].

[para] [emph Beware] that the directory tree generated by this command
       sequence differs from the directory tree generated by
       [cmd {make install}] and variants.

[para] [cmd {make install}] generates two package directories, one for
       Tcllib, the other for Tcllibc.

[para] The above sequence on the other hand places Tcllibc into a
       sub-directory of the Tcllib package directory.
