[comment {-*- tcl -*- doctools manpage}]
[manpage_begin tcl::chan::textwindow n 1.1]
[keywords {reflected channel}]
[keywords {text widget}]
[keywords {tip 219}]
[keywords Tk]
[keywords {virtual channel}]
[copyright {2009 Andreas Kupries <andreas_kupries@users.sourceforge.net>}]
[moddesc   {Reflected/virtual channel support}]
[category  Channels]
[titledesc {Textwindow channel}]
[require Tcl "8.5 9"]
[require TclOO]
[require tcl::chan::events [opt 1.1]]
[require tcl::chan::textwindow [opt 1.1]]
[description]
[para]

The [package tcl::chan::textwindow] package provides a command creating
write-only channels connected to text widgets. Anything written to the
channel is printed into the associated widget.

[para] The internal [package TclOO] class implementing the channel
handler is a sub-class of the [package tcl::chan::events] framework.

[section API]

[list_begin definitions]

[call [cmd ::tcl::chan::textwindow] [arg widget]]

This command creates a new textwindow channel and returns its handle.
Data written to this channel will appear in the associated [arg widget].

[list_end]

[vset CATEGORY virtchannel]
[include ../common-text/feedback.inc]
[manpage_end]
